###############################################################################
# RecentSelf.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################
# Last Updated:  Januar 05, 2004                                              #
###############################################################################

sub RecentTopics {
	my $display = 25; 	# number of latest topics

	my $viewsn=1;		# 1 = enable , 0 = disable 
	my $widthsn=20;		# width size of sn 

	my $viewboard=0;	# 1 = enable , 0 = disable 
	my $widthboard=200;	# width size of boardname
	my $widthsub=200;	# width size of subject

	my $viewicon=0;		# 1 = enable , 0 = disable 
	my $widthicon=30;	# width size of icon 

	my $viewuser=0;		# 1 = enable , 0 = disable 
	my $widthuser=100;	# width size of username 

	my $viewdate=0;		# 1 = enable , 0 = disable 
	my $widthdate=150;	# width size of date 

	my( @memset, @categories, %data, %cat, $numfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	$widthtable=$widthsub;
	if ($viewsn)    { $widthtable=$widthtable+$widthsn; }
	if ($viewboard) { $widthtable=$widthtable+$widthboard; }
	if ($viewicon)  { $widthtable=$widthtable+$widthicon; }
	if ($viewuser)  { $widthtable=$widthtable+$widthuser; }
	if ($viewdate)  { $widthtable=$widthtable+$widthdate; }

	$numfound=0;

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			$ii = @threads > $display ? $display : @threads;
			for ($i = 0; $i < $ii; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				$mtime = stringtotime($tdate);
				$data[$numfound] = "$mtime|$curboard|$tnum|$treplies";
				$numfound++;
			}
		}
	}

	@data = reverse sort @data;
	$numfound=0;

	for ($i = 0; $i < @data; $i++) {
		($mtime, $curboard, $tnum, $treplies) = split( /\|/, $data[$i] );

		fopen(FILE, "$datadir/$tnum.txt") || next;
		while( <FILE> ) { $message = $_; }
		# get only the last post for this thread.
		fclose(FILE);
		chomp $message;

		if( $message ) {
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
			$messages[$numfound] = "$curboard|$tnum|$treplies|$msub|$mname|$mdate|$musername|$micon";
			$numfound++;
		}
		if ($numfound >= $display) {last;}
	}

	print "Content-type: text/html\n\n";

	if( $numfound>0 ) {
		$counter = 1;
		# Load Censor List
		&LoadCensorList;
		$yyrecent = qq~<table border=0 width=$widthtable cellspacing=0 $color{'bordercolor CELLPADDING="0"'}>
~;
		for( $i = 0; $i < $numfound; $i++ ) {
			($board, $tnum, $c, $msub, $mname, $mdate, $musername, $micon) = split( /\|/, $messages[$i] );

			$displayname = $mname;
			if( $musername ne 'Guest' ) {
				&LoadUser($musername);
				$mname = exists $userprofile{$musername} ? $userprofile{$musername}->[1] : $mname;
				$mname ||= $txt{'470'};
				$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" alt="$txt{'27'}: $musername">$mname</a>~;
			}
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$mdate = &timeformat($mdate);

			$yyrecent .= qq~ <tr>
~;
			if ($viewsn)    { $yyrecent .= qq~  <td align=right WIDTH=$widthsn><b><FONT SIZE="-2">$counter.</FONT></b></td>
~; }
			if ($viewboard) { $yyrecent .= qq~  <td align=right WIDTH=$widthboard><b><FONT SIZE="-2">$boardinfo{$board}->[0]</FONT></b></td>
~; }
			if ($viewicon)  { $yyrecent .= qq~  <td align=center WIDTH=$widthicon><img src="$imagesdir/$micon.gif" alt=$micon ></td>
~; }
					  $yyrecent .= qq~  <td align=left WIDTH=$widthsub><FONT SIZE="-2"><a href="$scripturl?board=$board;action=display;num=$tnum;start=$c#$c">$msub</a></FONT></td>
~;
			if ($viewuser)  { $yyrecent .= qq~  <td align=left WIDTH=$widthuser><FONT SIZE="-2">$mname</FONT></td>
~; }
			if ($viewdate)  { $yyrecent .= qq~  <td align=left WIDTH=$widthdate><FONT SIZE="-2">$mdate</FONT></td>
~; }
			$yyrecent .= qq~ </tr>
~;

			++$counter;
		}
		$yyrecent .= qq~</table>
~;
	}
	else {
		print qq~<hr><b>$txt{'170'}</b><hr>~;
	}

	print <<"EOT";
$yyrecent
EOT
	exit;
}

1;